namespace sGUI

declare function TO_KeyAddChar(gad as _Gadget ptr,c as string)as integer

declare function TO_KeyBackspace(gad as _Gadget ptr)as integer
declare function TO_KeyDelete(gad as _Gadget ptr)as integer
declare function TO_KeyReturn(gad as _Gadget ptr)as integer

declare function TO_SetCursor overload(gad as _Gadget ptr,l as integer,p as integer)as integer
declare function TO_SetCursor(gad as _Gadget ptr,l as Textline ptr,p as integer)as integer
declare function TO_SetCursorToTextStart (gad as _Gadget ptr)  as integer
declare function TO_SetCursorToTextEnd (gad as _Gadget ptr)  as integer
declare function TO_SetCursorToLastLine (gad as _Gadget ptr) as integer
declare function TO_CursorUp(gad as _Gadget ptr)as integer
declare function TO_CursorDown(gad as _Gadget ptr)as integer
declare function TO_CursorLeft(gad as _Gadget ptr)as integer
declare function TO_CursorRight(gad as _Gadget ptr)as integer
'added by MilkFreeze, modified by Muttonhead :)
declare function TO_CursorKeyPos1(gad as _Gadget ptr)as integer
declare function TO_CursorKeyEnd(gad as _Gadget ptr)as integer

declare function TO_GetCursorLine(gad as _Gadget ptr) as integer
declare function TO_GetCursorPosition(gad as _Gadget ptr) as integer
declare function TO_GetLines (gad as _Gadget ptr) as integer
declare function TO_GetLineAddr(gad as _Gadget ptr,i as integer) as TextLine ptr
declare function TO_GetLineIndex(gad as _Gadget ptr,r as TextLine ptr) as integer
declare function TO_GetLongestLine(gad as _Gadget ptr) as integer

declare function TO_LoadText (gad as _Gadget ptr,s as string,linebreak as string=chr(13,10)) as integer
declare function TO_SetText (gad as _Gadget ptr,s as string,linebreak as string=chr(13,10)) as integer

declare function TO_SaveText (gad as _Gadget ptr,filename as string, linebreak as string=chr(13,10))as integer
declare function TO_GetText (gad as _Gadget ptr,linebreak as string=chr(13,10)) as string
declare function TO_GetLineContent overload(gad as _Gadget ptr,i as integer) as string
declare function TO_GetLineContent (gad as _Gadget ptr,l as TextLine ptr) as string
declare function TO_SetLineContent overload(gad as _Gadget ptr,i as integer,t as string)as integer
declare function TO_SetLineContent (gad as _Gadget ptr,l as TextLine ptr,t as string)as integer
declare function TO_AppendLine (gad as _Gadget ptr,t as string) as integer
declare function TO_ClearText (gad as _Gadget ptr) as integer

declare function GetValidTOAddress(gad as _Gadget ptr) as TextObject ptr

function TO_KeyAddChar(gad as _Gadget ptr,c as string)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->KeyAddChar(c)
    function=1
  end if
end function



function TO_KeyBackspace(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->KeyBackspace
    function=1
  end if
end function


function TO_KeyDelete(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->KeyDelete
    function=1
  end if
end function



function TO_KeyReturn(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->KeyReturn
    function=1
  end if
end function



function TO_SetCursor overload(gad as _Gadget ptr,l as integer,p as integer)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetCursor(l,p)
    function=1
  end if
end function



function TO_SetCursor(gad as _Gadget ptr,l as Textline ptr,p as integer)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetCursor(l,p)
    function=1
  end if
end function



function TO_SetCursorToTextStart(gad as _Gadget ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetCursorToTextStart
    function=1
  end if
end function



function TO_SetCursorToTextEnd (gad as _Gadget ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetCursorToTextEnd
    function=1
  end if
end function



function TO_SetCursorToLastLine (gad as _Gadget ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetCursorToLastLine
    function=1
  end if
end function



function TO_CursorUp(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->CursorUp
    function=1
  end if
end function



function TO_CursorDown(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->CursorDown
    function=1
  end if
end function



function TO_CursorLeft(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->CursorLeft
    function=1
  end if
end function



function TO_CursorRight(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->CursorRight
    function=1
  end if
end function



function TO_CursorKeyPos1(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->CursorKeyPos1
    function=1
  end if
end function



function TO_CursorKeyEnd(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->CursorKeyEnd
    function=1
  end if
end function



function TO_GetCursorLine(gad as _Gadget ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetCursorLine
end function



function TO_GetCursorPosition(gad as _Gadget ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetCursorPosition
end function



function TO_GetLines (gad as _Gadget ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetLines
end function



function TO_GetLineAddr(gad as _Gadget ptr,i as integer) as TextLine ptr
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetLineAddr(i)
end function



function TO_GetLineIndex(gad as _Gadget ptr,l as TextLine ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetLineIndex(l)
end function



function TO_GetLongestLine(gad as _Gadget ptr) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetLongestLine
end function



function TO_LoadText(gad as _Gadget ptr,filename as string,linebreak as string=chr(13,10)) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->LoadText(filename,linebreak)
    function=1
  end if
end function



function TO_SetText(gad as _Gadget ptr,s as string,linebreak as string=chr(13,10)) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetText (s,linebreak)
    function=1
  end if
end function



function TO_SaveText (gad as _Gadget ptr,filename as string, linebreak as string=chr(13,10)) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SaveText (filename, linebreak)
    function=1
  end if
end function



function TO_GetText (gad as _Gadget ptr,linebreak as string=chr(13,10)) as string
  function=""
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetText(linebreak)
end function



function TO_GetLineContent (gad as _Gadget ptr,i as integer) as string
  function=""
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetLineContent (i)
end function



function TO_GetLineContent (gad as _Gadget ptr,l as TextLine ptr) as string
  function=""
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then function=addrTO->GetLineContent (l)
end function



function TO_SetLineContent (gad as _Gadget ptr,i as integer,t as string)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetLineContent(i,t)
    function=1
  end if
end function



function TO_SetLineContent (gad as _Gadget ptr,l as TextLine ptr,t as string)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->SetLineContent(l,t)
    function=1
  end if
end function



function TO_AppendLine (gad as _Gadget ptr,t as string) as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->AppendLine (t)
    function=1
  end if
end function



function TO_ClearText(gad as _Gadget ptr)as integer
  function=0
  dim as TextObject ptr addrTO=GetValidTOAddress(gad)
  if addrTO then
    addrTO->ClearText
    function=1
  end if
end function



'diese Funktion liefert ,so gegeben, immer zuerst die Adresse des internen TOs
'falls dieses nicht gesetzt wird versucht die Adresse des externen zu bergeben.
'bei Fehlschlag liefert es 0
function GetValidTOAddress(gad as _Gadget ptr) as TextObject ptr
  function=0
  if gad->TO_internal then 
    function=gad->TO_internal
  elseif gad->TO_external then
    function=gad->TO_external
  end if
end function

end namespace

