'Dieses Programm erzeugt eine sogenannte "ClickMap", eine BMP welche die Lage der
'einzelnen Mulden auf dem Spielfeld definiert.
'Jede Mulde hat einen eigenen Farbwert.
'Dieser RGB-Wert entspricht direkt der spteren Indexnummer im Spielfeld-Array.
'Dadurch kann der Code im Hauptprogramm etwas bersichtlicher gehalten werden:
'(wieder mal) ein kleines Spezial-Gadget fr sGUI wertet diese ClickMap aus und liefert den Index der angeklickten Mulde
'fr die Abfrage des Spielfeldes muss jetzt nur ein Gadget erzeugt werden, anstatt 61 sich berschneidende Gadgets!

'basierend auf dieser ClickMap ist dann die eigentliche Bildschirm-Grafik fr das Spielfeld entstanden

'Lage der Mulden bzw deren RGB/Indexwert:
'Reihe 1: 1  - 5
'Reihe 2: 6  - 11
'Reihe 3: 12 - 18
'Reihe 4: 19 - 26
'Reihe 5: 27 - 35
'Reihe 6: 36 - 43
'Reihe 7: 44 - 50
'Reihe 8: 51 - 56
'Reihe 9: 57 - 61


'Radius der Mulde = 17,nicht verndern!!!!
'durch ihn wird alles andere berechnet/ beeinflusst
'alle GFX-Positionen im Hauptprogramm bzw Includes sind hardgecoded und verlassen sich
'derzeit darauf das die ClickMap mit dieser Vorraussetzung erzeugt wurde.

screen 18,32

dim as integer i,radius,xspace,yspace,xo,yo,col,ix,iy
dim as integer ptr img

radius=17

xspace=radius*2+3
yspace=radius*1.8

ix=xspace*9-2
iy=yspace*8 + 2*radius+1
img=imagecreate(ix,iy)


line(0,0)-(ix-1,iy-1),&HFF00FF,bf


'Reihe 1:
xo=radius+(radius+2)*4
yo=radius
col=1
for i=0 to 4
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 2:
xo=radius+(radius+2)*3
yo +=yspace
col=6
for i=0 to 5
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 3:
xo=radius+(radius+2)*2
yo +=yspace
col=12
for i=0 to 6
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 4:
xo=radius+(radius+2)*1
yo +=yspace
col=19
for i=0 to 7
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 5:
xo=radius+(radius+2)*0
yo +=yspace
col=27
for i=0 to 8
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 6:
xo=radius+(radius+2)*1
yo +=yspace
col=36
for i=0 to 7
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 7:
xo=radius+(radius+2)*2
yo +=yspace
col=44
for i=0 to 6
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 8:
xo=radius+(radius+2)*3
yo +=yspace
col=51
for i=0 to 5
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

'Reihe 9:
xo=radius+(radius+2)*4
yo+=yspace
col=57
for i=0 to 4
	circle(xo+xspace*i,yo),radius,col+i,,,,f
next i

get (0,0)-(ix-1,iy-1),img
bsave "ClickMap.bmp", img
imagedestroy img

print "bitte Taste druecken..."
sleep
end
